import React from 'react';

import type { GeneralSizeProp } from '@/mui/types';

import { isRestrictedSelector } from '@/modules/feeds/Editor/redux/selectors';
import { setAction } from '@/modules/feeds/Editor/redux/slices';

import { useFormSettings } from '@/modules/@common/Form';
import { useAppDispatch, useAppSelector } from '@/modules/@common/store/hooks';
import { Switch } from '@/mui/components';

type PropTypes = {
  disabled?: boolean;
};

function Restricted({ disabled = false }: PropTypes) {
  const dispatch = useAppDispatch();
  const { size } = useFormSettings();

  const isRestricted = useAppSelector(isRestrictedSelector);

  return (
    <Switch
      data-id="isRestricted"
      size={size as GeneralSizeProp}
      color="primary"
      checked={isRestricted}
      disabled={disabled}
      onChange={(e) => dispatch(setAction({ isRestricted: e.target.checked }))}
    />
  );
}

export default Restricted;
